'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

const React = require('react');

const AwardContext_1 = require('award-utils/AwardContext');
/**
 * 获取award context数据
 
 ```
<Consumer>
  {(award)=>{
    // setAward的数据传递到这里
    console.log(award);
  }}
</Consumer>
 ```
 */

class Consumer extends React.Component {
  shouldComponentUpdate() {
    return false;
  }

  render() {
    return React.createElement(AwardContext_1.default.Consumer, null, (award) => {
      return this.props.children(award);
    });
  }
}

exports.default = Consumer;
