'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

const React = require('react');

const react_helmet_1 = require('react-helmet');

const loadParams_1 = require('award-utils/loadParams');

exports.default = (props) => {
  const { children, ...rests } = props;
  const { ssr, isSwitchRouter, firstRender, routes } = loadParams_1.default.get();

  if (ssr) {
    if (routes.length) {
      // 当前页面存在路由
      if (!isSwitchRouter) {
        return null;
      }
    } else {
      // 当前页面不存在路由
      if (firstRender) {
        return null;
      }
    }
  }

  return React.createElement(react_helmet_1.Helmet, Object.assign({}, rests), children);
};
