'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.basename = exports.removeAward = exports.setAward = exports.start = exports.Consumer = exports.Head = void 0;

const loadParams_1 = require('award-utils/loadParams');

const head_1 = require('./head');

const consumer_1 = require('./consumer');

const start_1 = require('./start');

const setAward_1 = require('./setAward');

const removeAward_1 = require('./removeAward');

var head_2 = require('./head');

Object.defineProperty(exports, 'Head', {
  enumerable: true,
  get: function () {
    return head_2.default;
  }
});

var consumer_2 = require('./consumer');

Object.defineProperty(exports, 'Consumer', {
  enumerable: true,
  get: function () {
    return consumer_2.default;
  }
});

var start_2 = require('./start');

Object.defineProperty(exports, 'start', {
  enumerable: true,
  get: function () {
    return start_2.default;
  }
});

var setAward_2 = require('./setAward');

Object.defineProperty(exports, 'setAward', {
  enumerable: true,
  get: function () {
    return setAward_2.default;
  }
});

var removeAward_2 = require('./removeAward');

Object.defineProperty(exports, 'removeAward', {
  enumerable: true,
  get: function () {
    return removeAward_2.default;
  }
});

if (process.env.RUN_ENV === 'web') {
  let webBasename = '';
  ('<$>__AWARD__BASENAME__<$>');

  if (window.awardBasename) {
    webBasename = window.awardBasename;
  }

  loadParams_1.default.set({
    basename: webBasename
  });
}

const basename = () => {
  return loadParams_1.default.get().basename;
};

exports.basename = basename;
const _default = {
  Head: head_1.default,
  start: start_1.default,
  Consumer: consumer_1.default,
  setAward: setAward_1.default,
  removeAward: removeAward_1.default,
  basename: exports.basename
}; // 需要区分服务端和客户端读取插件默认导出的资源

let _award_plugins_ = null;

if (process.env.RUN_ENV === 'node') {
  // 服务端
  _award_plugins_ = global.__AWARD__PLUGINS__;
} else {
  /**
   * 客户端，babel识别到<$>__AWARD__PLUGINS__<$>，那么将对其注入下面插件代码
   * {
   *   "award-plugin-dva":{
   *     name: 'dva',
   *     default: require('award-plugin-dva'),
   *     client: require('award-plugin-dva/lib')
   *   }
   * }
   */
  ('<$>__AWARD__PLUGINS__<$>');
} // 分析插件结构，并导出资源

if (_award_plugins_) {
  Object.values(_award_plugins_).forEach((plugin) => {
    const api = plugin.default;
    const name = plugin.name;

    if (api) {
      _default[name] = api.default || api;
      exports[name] = api.default || api;
    }
  });
}

exports.default = _default;
