'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function decode(input) {
  try {
    return decodeURIComponent(input.replace(/\+/g, ' '));
  } catch (e) {
    return null;
  }
}

function querystring(query) {
  let parser = /([^=?&]+)=?([^&]*)/g;
  const result = {};
  let part;

  while ((part = parser.exec(query))) {
    let key = decode(part[1]);
    let value = decode(part[2]);
    if (key === null || value === null || key in result) continue;
    result[key] = value;
  }

  return result;
}

exports.default = querystring;
