'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.clean = void 0;

const loadParams_1 = require('award-utils/loadParams');

const initial_state_1 = require('./shared/initial_state');

let setAward = null;
/**
 * 客户端全局store
 */

exports.default = (data) => {
  if (typeof data === 'function') {
    // 存储setAward方法
    setAward = data;
  } else {
    if (process.env.RUN_ENV === 'node') {
      // 如果发现在服务器上执行该方法，说明有问题
      console.warn('setAward方法在服务端不生效');
    } else {
      const { firstRender } = loadParams_1.default.get();

      if (firstRender) {
        // 首次渲染，说明还未渲染出setAward处理组件，需要把数据传给INITIAL_STATE
        if (data && data.constructor === Object && Object.keys(data).length) {
          initial_state_1.INITIAL_STATE.award = { ...initial_state_1.INITIAL_STATE.award, ...data };
        } else {
          console.warn('setAward必须接受一个不为空的对象');
        }
      } else {
        if (typeof setAward === 'function') {
          return setAward(data);
        }
      }
    }
  }
};

const clean = () => {
  setAward = null;
};

exports.clean = clean;
